
Imports system
Imports System.Text
Imports System.Net
Imports System.Net.Sockets
Imports System.Runtime.InteropServices


Public Class frmMain

#Region "private parameters"
    'Treeview root node
    Private rNode As Windows.Forms.TreeNode
    'globle SEC definition
    Private gSec As sSEC = New sSEC

    'udp broadcast port
    Private Const uPort As UInt16 = 4127
    'socket 
    Private WithEvents sckUDP As New clsSckUDP 'Searching & setting
    Private WithEvents sckTCP As New clsSckTCP 'Firmware updating
    'ip end point
    Private UdpRemoteEP As IPEndPoint
    'firmware uploading related parameters
    Private fLen As Long = 0
    Private fStrm As IO.FileStream
    Private Const bufLen As Integer = 1024
    Private buf(bufLen - 1) As Byte
    Private sOffset As Long = 0
    Private rxLen As Long = 0
    'searching message
    Private SrchMsg() As Byte = {Asc("F"), Asc("I"), Asc("N"), Asc("D")}

#End Region
#Region "defined data item for combobox"
    'my data item for combobox
    Private Structure myDataItem
        Dim Name As String
        Dim rVal As Byte
        Public Sub New(ByVal _name As String, ByVal _value As Byte)
            Name = _name
            rVal = _value
        End Sub
        Public Overrides Function ToString() As String
            Return Me.Name
        End Function
    End Structure
#End Region
#Region "parsing functions"
    Private Function isIpAddr(ByVal ip As String) As Boolean
        If ip.Length > 0 Then
            Dim s() As String = Split(ip, ".")
            If s.Length = 4 Then
                For i As Int16 = 0 To 3
                    Try
                        If CType(s(i), Int16) > 255 Or CType(s(i), Int16) < 0 Then
                            Return False
                            Exit For
                        End If
                    Catch ex As Exception
                        Return False
                        Exit For
                    End Try
                Next
                Return True
            Else
                Return False
            End If
        Else
            Return False
        End If

    End Function
    'Convert bytes to MAC address string
    Private Function BytesToMacStr(ByVal b() As Byte) As String
        Dim sMac As String = ""
        For i As UInt16 = 0 To 5
            sMac += b(i).ToString("X2") & ":"
        Next
        sMac = sMac.Substring(0, sMac.Length - 1)
        Return sMac
    End Function
    'Converty MAC address string to bytes
    Private Function MacStrToBytes(ByVal Mac As String) As Byte()
        Dim bMac(5) As Byte
        Dim sMac() As String = Mac.Split(":")
        If sMac.Length = 6 Then
            For i As UInt16 = 0 To 5
                Try
                    bMac(i) = CType(sMac(i), Byte)
                Catch ex As Exception
                    MessageBox.Show("Invalid MAC address format!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End Try
            Next
        Else
            MessageBox.Show("Invalid MAC address format!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
        Return bMac
    End Function
    'Convert bytes to version string
    Private Function BytesToVerStr(ByVal b() As Byte) As String
        Return b(0).ToString & "." & b(1).ToString
    End Function
    'Convert version string to bytes

    'Calculate IP address string from bytes
    Private Function BytesToIpStr(ByVal b() As Byte) As String
        Dim ret As String = ""
        For i As UInt16 = 0 To 3
            ret += b(i).ToString & "."
        Next
        ret = ret.Substring(0, ret.Length - 1)
        Return ret
    End Function
    'Convert IP address string to bytes
    Private Function IpStrToBytes(ByVal Ip As String) As Byte()
        Dim ret(3) As Byte
        Dim sIP() As String = Ip.Split(".")
        If sIP.Length = 4 Then
            For i As UInt16 = 0 To 3
                Try
                    ret(i) = CType(sIP(i), Byte)
                Catch ex As Exception
                    MessageBox.Show("Invalid IP address format!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End Try
            Next
        Else
            MessageBox.Show("Invalid IP address format!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
        Return ret
    End Function
    'SEC Structure
    <StructLayout(LayoutKind.Sequential)> _
    Private Structure sSEC
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Dim Op() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=6)> _
        Dim MAC() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Dim LocalIP() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Dim SubnetMask() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Dim GatewayIP() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Dim DnsIP() As Byte
        Dim IpMode As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim Ver() As Byte
        Dim Debug As Byte

        ''UART0
        Dim Mode0 As Byte

        'state
        Dim state0 As Byte

        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim lPort0() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Dim rIp0() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim rPort0() As Byte
        Dim Baudrate0 As Byte
        Dim DataBit0 As Byte
        Dim Parity0 As Byte
        Dim StopBit0 As Byte
        Dim FlowControl0 As Byte

        Dim dnsFlag0 As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=32)> _
        Dim rDomain0() As Byte

        'keep alive
        Dim kaFlag0 As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim kaPeriod0() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim kaCount0() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim kaInterval0() As Byte

        'options
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim nagle0() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim inactivity0() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim reconn0() As Byte
        ''UART0 END

        ''UART1
        Dim Mode1 As Byte

        'state
        Dim state1 As Byte

        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim lPort1() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Dim rIp1() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim rPort1() As Byte
        Dim Baudrate1 As Byte
        Dim DataBit1 As Byte
        Dim Parity1 As Byte
        Dim StopBit1 As Byte
        Dim FlowControl1 As Byte

        Dim dnsFlag1 As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=32)> _
        Dim rDomain1() As Byte

        'keep alive
        Dim kaFlag1 As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim kaPeriod1() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim kaCount1() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim kaInterval1() As Byte

        'options
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim nagle1() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim inactivity1() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim reconn1() As Byte
        ''UART1 END

        'md5 digest
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
        Dim pwd() As Byte

        'device name and serial number
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
        Dim deviceName() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
        Dim deviceSerial() As Byte

        'NTP
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Dim ntp_domain() As Byte
        Dim time_zone As Byte
        Dim ntp_flag As Byte

        'date time by user input
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Dim year() As Byte
        Dim month As Byte
        Dim day As Byte
        Dim hour As Byte
        Dim minute As Byte
        Dim second As Byte

        'Serial Configuration
        Dim serial_conf As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=3)> _
        Dim serial_trigger() As Byte

    End Structure


    'Calculate SEC from bytes
    Private Function BytesToSec(ByVal dat() As Byte) As sSEC
        Dim sec As sSEC = New sSEC
        Dim size As Integer = Marshal.SizeOf(sec)
        Dim pPoint As IntPtr = Marshal.AllocHGlobal(size)
        Try
            Marshal.Copy(dat, 0, pPoint, size)
            sec = CType(Marshal.PtrToStructure(pPoint, sec.GetType()), sSEC)
            Return sec
        Finally
            Marshal.FreeHGlobal(pPoint)
        End Try
    End Function
    'Convert SEC to bytes
    Private Function SecToBytes(ByVal sec As sSEC) As Byte()
        Dim size As Integer = 0
        Try
            size = Marshal.SizeOf(sec)
        Catch ex As Exception
        End Try
        Dim buffer As IntPtr = Marshal.AllocHGlobal(size)
        'Try
        Marshal.StructureToPtr(sec, buffer, True)
        Dim bytes(size - 1) As Byte
        Marshal.Copy(buffer, bytes, 0, size)
        Return bytes
        'Catch ex As Exception
        'Return Nothing
        'Finally
        'Marshal.FreeHGlobal(buffer)
        'End Try
    End Function

#End Region
#Region "Delegate functions"

    Private Delegate Sub tvAddNodeCallback(ByVal tView As TreeView, ByVal pNode As Windows.Forms.TreeNode, ByVal sec As sSEC)
    Private Sub tvAddNode(ByVal tView As TreeView, ByVal pNode As Windows.Forms.TreeNode, ByVal sec As sSEC)

        If tView.InvokeRequired Then
            Dim d As New tvAddNodeCallback(AddressOf tvAddNode)
            Me.Invoke(d, New Object() {[tView], [pNode], [sec]})
        Else
            Dim nd As Windows.Forms.TreeNode
            Dim sel_nd As Windows.Forms.TreeNode = Nothing
            Dim idx As Integer = 0
            Dim isExist As Boolean = False
            For Each nd In pNode.Nodes
                If nd.Text = BytesToMacStr(sec.MAC) Then
                    isExist = True
                    idx += 1
                    sel_nd = nd
                    Exit For
                End If
            Next
            If Not isExist Then
                Dim cNode As Windows.Forms.TreeNode = pNode.Nodes.Add(BytesToMacStr(sec.MAC))
                If (sec.Ver(0) And &H80) = &H80 Then
                    cNode.Nodes.Add("Bootloader Version: " & sec.Ver(0) - &H80 & "." & sec.Ver(1))
                Else
                    cNode.Nodes.Add("Firmware Version: " & BytesToVerStr(sec.Ver))
                End If

                cNode.Tag = sec
                'set globle gSec
                gSec = sec
                'select the new added node
                sel_nd = cNode
            Else
                Dim cNode As Windows.Forms.TreeNode = sel_nd 'pNode.Nodes(idx - 1)
                cNode.Tag = sec
                'set globle gSec
                gSec = sec
                'select the modified node
                sel_nd = cNode
            End If
            If pNode.Nodes.Count > 0 Then
                pNode.Expand()
                If pNode.Nodes.Count > 1 Then
                    'sort
                    tv.Sort()
                    tv.SelectedNode = sel_nd
                End If
            End If
        End If

    End Sub
    Private Delegate Sub enToolbarCallback(ByVal tsb As ToolStripButton, ByVal en As Boolean)
    Private Sub enToolBar(ByVal tsb As ToolStripButton, ByVal en As Boolean)
        If tsb.Owner.InvokeRequired Then
            Dim d As New enToolbarCallback(AddressOf enToolBar)
            Me.Invoke(d, New Object() {[tsb], [en]})
        Else
            tsb.Enabled = en
        End If
    End Sub
    Private Delegate Sub progressbarCallback(ByVal pb As ToolStripProgressBar, ByVal val As Integer)
    Private Sub progressbar(ByVal pb As ToolStripProgressBar, ByVal val As Integer)
        If pb.Owner.InvokeRequired Then
            Dim d As New progressbarCallback(AddressOf progressbar)
            Me.Invoke(d, New Object() {[pb], [val]})
        Else
            pb.Value = val
        End If
    End Sub
    Private Delegate Sub toolstripLblMsgCallback(ByVal tLabel As ToolStripLabel, ByVal msg As String)
    Private Sub tLabelmsg(ByVal tLabel As ToolStripLabel, ByVal msg As String)
        If tLabel.Owner.InvokeRequired Then
            Dim d As New toolstripLblMsgCallback(AddressOf tLabelmsg)
            Me.Invoke(d, New Object() {[tLabel], [msg]})
        Else
            tLabel.Text = msg
        End If
    End Sub
#End Region
#Region "TreeView Operation"
    Private Function tvAddRootNode(ByVal tView As TreeView, ByVal sName As String) As TreeNode
        Dim nd As TreeNode

        If sName.Length > 0 Then
            nd = tView.Nodes.Add(sName)
        Else
            nd = tView.Nodes.Add("Invalid node name!")
        End If
        Return nd

    End Function
    Private Function RemoveOneNode(ByVal tView As TreeView, ByVal pNode As Windows.Forms.TreeNode, ByVal nd As Windows.Forms.TreeNode) As String
        Dim ret As String = ""
        pNode.Nodes.Remove(nd)
        ret = nd.Text & " removed from the search results."
        Return ret
    End Function
    Private Sub RemoveAllNodes(ByVal pNode As Windows.Forms.TreeNode)
        pNode.Nodes.Clear()
    End Sub

#End Region
#Region "Main form control methods"
    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Dim ret As DialogResult = MessageBox.Show("Are you sure to exit?", "Exit", MessageBoxButtons.YesNo, MessageBoxIcon.Information)
        If ret = Windows.Forms.DialogResult.Yes Then
            'close program
            End
        Else
            e.Cancel = True
        End If
    End Sub
    Private Function md5(ByVal s As String) As String
        Dim ret As String = ""
        Dim dataToHash As Byte() = (New ASCIIEncoding).GetBytes(s)
        Dim hashValue As Byte() = CType(System.Security.Cryptography.CryptoConfig.CreateFromName("MD5"), System.Security.Cryptography.HashAlgorithm).ComputeHash(dataToHash)
        Dim i As Integer
        For i = 0 To 15
            ret += hashValue(i).ToString("X2")

        Next
        Return ret

    End Function
    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Me.Text = "WIZ127SR ConfigTool (Ver. " & Application.ProductVersion & ")"
        Dim b As Int16 = -9

        Dim h As Integer = &HFFF7

        'md5 test

        'Debug.Print(md5("abc"))


        'initialize controls
        'add combobox data
        With cboBaud
            .Items.Add(New myDataItem("1200", 0))
            .Items.Add(New myDataItem("2400", 1))
            .Items.Add(New myDataItem("4800", 2))
            .Items.Add(New myDataItem("9600", 3))
            .Items.Add(New myDataItem("19200", 4))
            .Items.Add(New myDataItem("38400", 5))
            .Items.Add(New myDataItem("57600", 6))
            .Items.Add(New myDataItem("115200", 7))
            .Items.Add(New myDataItem("230400", 8))
            .Items.Add(New myDataItem("460800", 9))
            .Items.Add(New myDataItem("921600", 10))
            .Items.Add(New myDataItem("1843200", 10))
        End With

        With cboDataBit
            .Items.Add(New myDataItem("7", 0))
            .Items.Add(New myDataItem("8", 1))
            .Items.Add(New myDataItem("9", 2))
        End With

        With cboStopBit
            .Items.Add(New myDataItem("0.5", 0))
            .Items.Add(New myDataItem("1", 1))
            .Items.Add(New myDataItem("1.5", 2))
            .Items.Add(New myDataItem("2", 3))
        End With

        With cboParity
            .Items.Add(New myDataItem("NONE", 0))
            .Items.Add(New myDataItem("ODD", 1))
            .Items.Add(New myDataItem("EVEN", 2))
        End With
        With cboFlow
            .Items.Add(New myDataItem("NONE", 0))
            .Items.Add(New myDataItem("CTS/RTS", 1))
            .Items.Add(New myDataItem("DSR/DTR", 2))
        End With

        With cboBaud1
            .Items.Add(New myDataItem("1200", 0))
            .Items.Add(New myDataItem("2400", 1))
            .Items.Add(New myDataItem("4800", 2))
            .Items.Add(New myDataItem("9600", 3))
            .Items.Add(New myDataItem("19200", 4))
            .Items.Add(New myDataItem("38400", 5))
            .Items.Add(New myDataItem("57600", 6))
            .Items.Add(New myDataItem("115200", 7))
            .Items.Add(New myDataItem("230400", 8))
            .Items.Add(New myDataItem("460800", 9))
            .Items.Add(New myDataItem("921600", 10))
            .Items.Add(New myDataItem("1843200", 10))
        End With

        With cboDataBit1
            .Items.Add(New myDataItem("7", 0))
            .Items.Add(New myDataItem("8", 1))
            .Items.Add(New myDataItem("9", 2))
        End With

        With cboStopBit1
            .Items.Add(New myDataItem("0.5", 0))
            .Items.Add(New myDataItem("1", 1))
            .Items.Add(New myDataItem("1.5", 2))
            .Items.Add(New myDataItem("2", 3))
        End With

        With cboParity1
            .Items.Add(New myDataItem("NONE", 0))
            .Items.Add(New myDataItem("ODD", 1))
            .Items.Add(New myDataItem("EVEN", 2))
        End With
        With cboFlow1
            .Items.Add(New myDataItem("NONE", 0))
            .Items.Add(New myDataItem("CTS/RTS", 1))
            .Items.Add(New myDataItem("DSR/DTR", 2))
        End With

        'tree view
        rNode = tvAddRootNode(tv, "Serial to Ethernet")
        tv.SelectedNode = rNode

        'create ip end point object
        UdpRemoteEP = New IPEndPoint(IPAddress.Broadcast, uPort)
        sckUDP.Bind(0)

        'disable txtpwd in order to handle a new pwd is input or not
        txtPwd.ReadOnly = True


    End Sub
    'searching all modules in the same subnet using UDP broadcast
    Private Sub tsbSrchAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbSrchAll.Click
        Call RemoveAllNodes(rNode)
        sckUDP.SendTo(SrchMsg, UdpRemoteEP)
    End Sub
    'setting selected module
    Private Sub tsbSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbSet.Click
        Dim sec As sSEC = New sSEC
        'Setting indicator
        sec.Op = Encoding.ASCII.GetBytes("SETT")
        sec.Ver = gSec.Ver
        sec.MAC = gSec.MAC
        Debug.Print(BytesToMacStr(gSec.MAC))

        sec.LocalIP = IpStrToBytes(txtLIP.Text.Trim)
        sec.GatewayIP = IpStrToBytes(txtGw.Text.Trim)
        sec.SubnetMask = IpStrToBytes(txtSubnet.Text.Trim)
        sec.DnsIP = IpStrToBytes(txtDNS.Text.Trim)
        If rbStatic.Checked Then
            sec.IpMode = 0
        ElseIf rbDHCP.Checked Then
            sec.IpMode = 1
        End If

        'uart0
        'mode: client, server, mixed, udp
        If rbTcpClient.Checked Then sec.Mode0 = 0
        If rbTcpServer.Checked Then sec.Mode0 = 1
        If rbTcpMixed.Checked Then sec.Mode0 = 2
        If rbUdp.Checked Then sec.Mode0 = 3
        sec.Baudrate0 = cboBaud.SelectedIndex
        sec.DataBit0 = cboDataBit.SelectedIndex
        sec.Parity0 = cboParity.SelectedIndex
        sec.StopBit0 = cboStopBit.SelectedIndex
        sec.FlowControl0 = cboFlow.SelectedIndex
        'dns flag & rIP, domain
        If txtRhost.Text.Trim.Length > 0 Then
            If isIpAddr(txtRhost.Text.Trim) Then
                sec.rIp0 = IpStrToBytes(txtRhost.Text.Trim)
                sec.dnsFlag0 = 0
            Else
                sec.rDomain0 = Encoding.ASCII.GetBytes(txtRhost.Text.Trim)
                ReDim Preserve sec.rDomain0(31)
                sec.dnsFlag0 = 1
            End If
        End If
        ReDim sec.rPort0(1) : ReDim sec.lPort0(1)
        sec.rPort0(0) = (CType(txtRport.Text.Trim, UInt16) And &HFF00) >> 8
        sec.rPort0(1) = CType(txtRport.Text.Trim, UInt16) Mod 256
        sec.lPort0(0) = (CType(txtLport.Text.Trim, UInt16) And &HFF00) >> 8
        sec.lPort0(1) = CType(txtLport.Text.Trim, UInt16) Mod 256
        'options
        ReDim sec.nagle0(1) : ReDim sec.inactivity0(1) : ReDim sec.reconn0(1)
        sec.nagle0(0) = (CType(txtNagle.Text.Trim, UInt16) And &HFF00) >> 8
        sec.nagle0(1) = CType(txtNagle.Text.Trim, UInt16) Mod 256
        sec.inactivity0(0) = (CType(txtInactivity.Text.Trim, UInt16) And &HFF00) >> 8
        sec.inactivity0(1) = CType(txtInactivity.Text.Trim, UInt16) Mod 256
        sec.reconn0(0) = (CType(txtReconn.Text.Trim, UInt16) And &HFF00) >> 8
        sec.reconn0(1) = CType(txtReconn.Text.Trim, UInt16) Mod 256

        'uart1
        'mode: client, server, mixed, udp
        If rbTcpClient1.Checked Then sec.Mode1 = 0
        If rbTcpServer1.Checked Then sec.Mode1 = 1
        If rbTcpMixed1.Checked Then sec.Mode1 = 2
        If rbUdp1.Checked Then sec.Mode1 = 3
        sec.Baudrate1 = cboBaud1.SelectedIndex
        sec.DataBit1 = cboDataBit1.SelectedIndex
        sec.Parity1 = cboParity1.SelectedIndex
        sec.StopBit1 = cboStopBit1.SelectedIndex
        sec.FlowControl1 = cboFlow1.SelectedIndex
        'dns flag & rIP, domain
        If txtRhost1.Text.Trim.Length > 0 Then
            If isIpAddr(txtRhost1.Text.Trim) Then
                sec.rIp1 = IpStrToBytes(txtRhost1.Text.Trim)
                sec.dnsFlag1 = 0
            Else
                sec.rDomain1 = Encoding.ASCII.GetBytes(txtRhost1.Text.Trim)
                ReDim Preserve sec.rDomain1(31)
                sec.dnsFlag1 = 1
            End If
        End If
        ReDim sec.rPort1(1) : ReDim sec.lPort1(1)
        sec.rPort1(0) = (CType(txtRport1.Text.Trim, UInt16) And &HFF00) >> 8
        sec.rPort1(1) = CType(txtRport1.Text.Trim, UInt16) Mod 256
        sec.lPort1(0) = (CType(txtLport1.Text.Trim, UInt16) And &HFF00) >> 8
        sec.lPort1(1) = CType(txtLport1.Text.Trim, UInt16) Mod 256
        'options
        ReDim sec.nagle1(1) : ReDim sec.inactivity1(1) : ReDim sec.reconn1(1)
        sec.nagle1(0) = (CType(txtNagle1.Text.Trim, UInt16) And &HFF00) >> 8
        sec.nagle1(1) = CType(txtNagle1.Text.Trim, UInt16) Mod 256
        sec.inactivity1(0) = (CType(txtInactivity1.Text.Trim, UInt16) And &HFF00) >> 8
        sec.inactivity1(1) = CType(txtInactivity1.Text.Trim, UInt16) Mod 256
        sec.reconn1(0) = (CType(txtReconn1.Text.Trim, UInt16) And &HFF00) >> 8
        sec.reconn1(1) = CType(txtReconn1.Text.Trim, UInt16) Mod 256

        'keep alive
        'If chkKa.Checked Then
        'sec.kaFlag = 1
        'Else
        'sec.kaFlag = 0
        'End If
        'ReDim sec.kaPeriod(1) : ReDim sec.kaInterval(1) : ReDim sec.kaCount(1)
        'sec.kaPeriod(0) = (CType(txtKaPeriod.Text.Trim, UInt16) And &HFF00) >> 8
        'sec.kaPeriod(1) = CType(txtKaPeriod.Text.Trim, UInt16) Mod 256
        'sec.kaInterval(0) = (CType(txtKaInterval.Text.Trim, UInt16) And &HFF00) >> 8
        'sec.kaInterval(1) = CType(txtKaInterval.Text.Trim, UInt16) Mod 256
        'sec.kaCount(0) = (CType(txtKaCount.Text.Trim, UInt16) And &HFF00) >> 8
        'sec.kaCount(1) = CType(txtKaCount.Text.Trim, UInt16) Mod 256

        'password
        'sec.pwd = Encoding.ASCII.GetBytes(txtPwd.Text.Trim)
        'check if the pwd is changed, 
        ReDim Preserve sec.pwd(15)
        Dim tmp As String = ""
        For i As Integer = 0 To 15
            tmp += gSec.pwd(i).ToString("X2")
        Next
        Debug.Print("tmp: " & tmp)

        txtPwd.Text = txtPwd.Text.Trim
        Debug.Print("txtpwd: " & txtPwd.Text)

        If txtPwd.Text <> tmp Then
            Dim b() As Byte = Encoding.Default.GetBytes(txtPwd.Text.Trim)
            sec.pwd = b
            ReDim Preserve sec.pwd(15)

        Else
            sec.pwd = gSec.pwd
            ReDim Preserve sec.pwd(15)
        End If

        'debug
        If chkDebug.Checked Then
            sec.Debug = 1
        Else
            sec.Debug = 0
        End If

        'device name & serial number
        sec.deviceName = Encoding.ASCII.GetBytes(txtDeviceName.Text.Trim)
        ReDim Preserve sec.deviceName(15)

        'NTP
        If chkNTP.Checked Then
            sec.ntp_flag = 1
        Else
            sec.ntp_flag = 0
        End If
        sec.ntp_domain = IpStrToBytes(txtNTPServerIP.Text.Trim)
        sec.time_zone = cboTimeZone.SelectedIndex + 1

        sec.deviceSerial = gSec.deviceSerial
        ReDim Preserve sec.deviceSerial(15)

        'Serial Configuration
        If chkSerialConf.Checked Then
            sec.serial_conf = 1
        Else
            sec.serial_conf = 0
        End If

        ReDim sec.serial_trigger(3)
        sec.serial_trigger(0) = Convert.ToByte(txtTirgger1.Text.Trim, 16)
        sec.serial_trigger(1) = Convert.ToByte(txtTirgger2.Text.Trim, 16)
        sec.serial_trigger(2) = Convert.ToByte(txtTirgger3.Text.Trim, 16)

        'send data
        Dim dat() As Byte = SecToBytes(sec)
        sckUDP.SendTo(dat, UdpRemoteEP)

    End Sub
    Private Sub tv_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tv.AfterSelect
        Dim lv As UInt16 = tv.SelectedNode.Level
        Dim nd As Windows.Forms.TreeNode = New Windows.Forms.TreeNode
        If lv > 0 Then
            If lv = 1 Then
                nd = tv.SelectedNode
            ElseIf lv = 2 Then
                nd = tv.SelectedNode.Parent
            End If

            Dim sec As sSEC = CType(nd.Tag, sSEC)
            '20120509
            gSec = sec

            If sec.IpMode = 0 Then
                rbStatic.Checked = True
            Else
                rbDHCP.Checked = True
            End If
            'Display values
            txtLIP.Text = BytesToIpStr(sec.LocalIP)
            txtSubnet.Text = BytesToIpStr(sec.SubnetMask)
            txtGw.Text = BytesToIpStr(sec.GatewayIP)
            txtDNS.Text = BytesToIpStr(sec.DnsIP)

            'UART0
            cboBaud.SelectedIndex = sec.Baudrate0
            cboDataBit.SelectedIndex = sec.DataBit0
            cboParity.SelectedIndex = sec.Parity0
            cboStopBit.SelectedIndex = sec.StopBit0
            cboFlow.SelectedIndex = sec.FlowControl0
            'mode
            Select Case sec.Mode0
                Case 0
                    rbTcpClient.Checked = True
                Case 1
                    rbTcpServer.Checked = True
                Case 2
                    rbTcpMixed.Checked = True
                Case 3
                    rbUdp.Checked = True
            End Select
            txtLport.Text = sec.lPort0(0) * 256 + sec.lPort0(1)
            txtRport.Text = sec.rPort0(0) * 256 + sec.rPort0(1)

            If sec.dnsFlag0 = 1 Then 'check domain name or ip address
                txtRhost.Text = Encoding.ASCII.GetString(sec.rDomain0)
            Else
                txtRhost.Text = BytesToIpStr(sec.rIp0)
            End If
            'options
            txtNagle.Text = sec.nagle0(0) * 256 + sec.nagle0(1)
            txtInactivity.Text = sec.inactivity0(0) * 256 + sec.inactivity0(1)
            txtReconn.Text = sec.reconn0(0) * 256 + sec.reconn0(1)
            'dns flat test
            Debug.Print(sec.dnsFlag0)

            'UART1
            cboBaud1.SelectedIndex = sec.Baudrate1
            cboDataBit1.SelectedIndex = sec.DataBit1
            cboParity1.SelectedIndex = sec.Parity1
            cboStopBit1.SelectedIndex = sec.StopBit1
            cboFlow1.SelectedIndex = sec.FlowControl1
            'mode
            Select Case sec.Mode1
                Case 0
                    rbTcpClient1.Checked = True
                Case 1
                    rbTcpServer1.Checked = True
                Case 2
                    rbTcpMixed1.Checked = True
                Case 3
                    rbUdp1.Checked = True
            End Select
            txtLport1.Text = sec.lPort1(0) * 256 + sec.lPort1(1)
            txtRport1.Text = sec.rPort1(0) * 256 + sec.rPort1(1)

            If sec.dnsFlag1 = 1 Then 'check domain name or ip address
                txtRhost1.Text = Encoding.ASCII.GetString(sec.rDomain1)
            Else
                txtRhost1.Text = BytesToIpStr(sec.rIp1)
            End If
            'options
            txtNagle1.Text = sec.nagle1(0) * 256 + sec.nagle1(1)
            txtInactivity1.Text = sec.inactivity1(0) * 256 + sec.inactivity1(1)
            txtReconn1.Text = sec.reconn1(0) * 256 + sec.reconn1(1)
            'dns flat test
            Debug.Print(sec.dnsFlag1)

            'keep alive
            'If sec.kaFlag Then
            'chkKa.Checked = True
            'txtKaPeriod.Enabled = True
            'txtKaCount.Enabled = True
            'Else
            'chkKa.Checked = False
            'txtKaPeriod.Enabled = False
            'txtKaCount.Enabled = False
            'txtKaInterval.Enabled = False
            'End If
            'txtKaPeriod.Text = sec.kaPeriod(0) * 256 + sec.kaPeriod(1)
            'txtKaCount.Text = sec.kaCount(0) * 256 + sec.kaCount(1)
            'txtKaInterval.Text = sec.kaInterval(0) * 256 + sec.kaInterval(1)

            'pwd
            'txtPwd.Text = Encoding.ASCII.GetString(sec.pwd)
            Dim tmp As String = ""
            For i As Integer = 0 To 15
                tmp += sec.pwd(i).ToString("X2")
            Next
            txtPwd.Text = tmp

            If sec.Debug Then
                chkDebug.Checked = True
            Else
                chkDebug.Checked = False
            End If

            'device name & serial number
            txtDeviceName.Text = Encoding.ASCII.GetString(sec.deviceName)
            txtSerialNumber.Text = Encoding.ASCII.GetString(sec.deviceSerial)

            'state
            If sec.state0 Then
                txtNetstatus1.Text = "Connected"
            Else
                txtNetstatus1.Text = "Disconnected"
            End If

            If sec.state1 Then
                txtNetstatus2.Text = "Connected"
            Else
                txtNetstatus2.Text = "Disconnected"
            End If

            'f/w version
            If (sec.Ver(0) And &H80) = &H80 Then
                txtFWver.Text = "Bootloader"
            Else
                txtFWver.Text = BytesToVerStr(sec.Ver)
            End If

            'NTP
            If sec.ntp_flag Then
                chkNTP.Checked = True
            Else
                chkNTP.Checked = False
            End If

            txtNTPServerIP.Text = BytesToIpStr(sec.ntp_domain)

            Dim year As Integer
            year = (sec.year(0) * 256) + sec.year(1)
            txtDeviceTime.Text = year.ToString + "-" + sec.month.ToString + "-" + sec.day.ToString + " " + sec.hour.ToString + ":" + sec.minute.ToString + ":" + sec.second.ToString

            cboTimeZone.SelectedIndex = sec.time_zone - 1

            'Serial Configuration
            If sec.serial_conf Then
                chkSerialConf.Checked = True
            Else
                chkSerialConf.Checked = False
            End If

            txtTirgger1.Text = Convert.ToString(sec.serial_trigger(0), 16)
            txtTirgger2.Text = Convert.ToString(sec.serial_trigger(1), 16)
            txtTirgger3.Text = Convert.ToString(sec.serial_trigger(2), 16)

            'enable controls
            tsbSet.Enabled = True
            tsbUpload.Enabled = True
            tsbFactory.Enabled = True

        Else
            'diable controls
            tsbSet.Enabled = False
            tsbUpload.Enabled = False
            tsbFactory.Enabled = False

        End If
        'pwd
        txtPwd.ReadOnly = True
    End Sub
    'Send firmware uploading command
    Private Sub tsbUpload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbUpload.Click
        'open file dialog
        Dim sFile As String = ""
        ofd.FileName = ""
        ofd.ShowDialog()
        sFile = ofd.FileName
        If sFile.Length > 0 Then
            fStrm = New IO.FileStream(sFile, IO.FileMode.Open, IO.FileAccess.Read, IO.FileShare.ReadWrite)
            fLen = fStrm.Length
            'initial progress bar
            tpb.Maximum = fLen
            tpb.Value = 0
            'toolstrip label message
            tlblMsg.Text = "Firmware uploading..."
            rxLen = 0
            sOffset = 0
            If fLen < (120) * 1024 Then 'firmware length must < 120KByte
                'set toolstripprogressbar
                tpb.Value = 0
                tpb.Maximum = fLen
                'send firmware upload command
                Dim dat(9) As Byte
                dat(0) = Asc("F")
                dat(1) = Asc("I")
                dat(2) = Asc("R")
                dat(3) = Asc("M")

                For i As Int16 = 0 To 5
                    dat(i + 4) = gSec.MAC(i)
                Next
                'dat(7) = Math.Truncate(fLen / 256)
                'dat(8) = fLen Mod 256
                sckUDP.SendTo(dat, UdpRemoteEP)
            Else
                MessageBox.Show("The length of firmware file should be less than 60K bytes.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If
        End If
    End Sub
    Private Sub tsbExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbExit.Click
        Me.Close()
    End Sub
#End Region
#Region "TCP/UDP processing"
    'UDP data arrival
    Private Sub sckUDP_DataArrival(ByVal len As Integer, ByVal dat() As Byte) Handles sckUDP.DataArrival
        Select Case Encoding.ASCII.GetString(dat, 0, 4)
            Case "FIND"
                'searching or setting response message
                Dim sec As sSEC = BytesToSec(dat)
                Call tvAddNode(tv, rNode, sec)
            Case "SETT"

                Dim sec As sSEC = BytesToSec(dat)
                Call tvAddNode(tv, rNode, sec)
                'enable tsmain

                enToolBar(tsbSet, True)
            Case "FIRM"
                '
                'firmware uploading command response message
                Dim sec As sSEC = BytesToSec(dat)
                Debug.Print("firware upload")
                Dim ipStr As String = sec.LocalIP(0).ToString & "." & sec.LocalIP(1).ToString & "." & sec.LocalIP(2).ToString & "." & sec.LocalIP(3).ToString
                Debug.Print("ip: " & ipStr)

                Dim tcpRemoteEP As IPEndPoint = New IPEndPoint(IPAddress.Parse(txtLIP.Text), 30000)
                sckTCP.Connect(tcpRemoteEP)
                'toolstrip label message
                tLabelmsg(tlblMsg, "Connecting with " & txtLIP.Text)

        End Select

    End Sub

    Private Sub sckUDP_SocketError(ByVal err As System.Exception) Handles sckUDP.SocketError
        MessageBox.Show(err.Message, "UDP Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub

    Private Sub sckTCP_Connected() Handles sckTCP.Connected
        'send file length
        Dim bFLen(3) As Byte
        bFLen(3) = (fLen And &HFF000000) >> 24
        bFLen(2) = (fLen And &HFF0000) >> 16
        bFLen(1) = (fLen And &HFF00) >> 8
        bFLen(0) = fLen Mod 256

        sckTCP.Send(4, bFLen)
        'toolstrip label message
        tLabelmsg(tlblMsg, "Connected")
        Debug.Print("flen sent")
    End Sub

    Private Sub sckTCP_DataArrival(ByVal len As Integer, ByVal dat() As Byte) Handles sckTCP.DataArrival
        Dim n As Long = 0
        If len = 4 Then
            n = dat(3) * 2 ^ 24 + dat(2) * 2 ^ 16 + dat(1) * 2 ^ 8 + dat(0)
            Debug.Print(n)
            If n = fLen Then
                n = 0
            End If

        End If
        'send firmware data

        rxLen += n
        'update progress bar & label message
        progressbar(tpb, rxLen)
        tLabelmsg(tlblMsg, (Math.Truncate((rxLen / fLen) * 100)).ToString & "%")

        If rxLen < fLen Then
            If fLen - rxLen > bufLen Then
                fStrm.Seek(sOffset, IO.SeekOrigin.Begin)
                fStrm.Read(buf, 0, bufLen)
                sOffset += bufLen
                sckTCP.Send(bufLen, buf)
                Threading.Thread.Sleep(200)
            Else
                Dim b(fLen - rxLen - 1) As Byte
                fStrm.Seek(sOffset, IO.SeekOrigin.Begin)
                fStrm.Read(b, 0, fLen - rxLen)
                sOffset += fLen - rxLen
                sckTCP.Send(fLen - rxLen, b)
            End If
        ElseIf rxLen = fLen Then
            fStrm.Close()


            'MessageBox.Show("Firmware download over.")

        End If
    End Sub

    Private Sub sckTCP_Disconnected() Handles sckTCP.Disconnected
        Debug.Print("disconnected")

        MessageBox.Show("Firmware download over.", "WIZ127SR ConfigTool", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Private Sub sckTCP_SocketError(ByVal err As System.Exception) Handles sckTCP.SocketError
        MessageBox.Show(err.Message, "TCP Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub
#End Region

    Private Sub txtPwd_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtPwd.DoubleClick

        txtPwd.ReadOnly = False
    End Sub

    Private Sub tsbFactory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbFactory.Click
        Dim dat(9) As Byte
        dat(0) = Asc("F")
        dat(1) = Asc("A")
        dat(2) = Asc("C")
        dat(3) = Asc("T")

        For i As Int16 = 0 To 5
            dat(i + 4) = gSec.MAC(i)
        Next

        sckUDP.SendTo(dat, UdpRemoteEP)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        'tsbSet_Click(sender, e)


    End Sub

    Private Sub chkDirectIP_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDirectIP.CheckedChanged
        If chkDirectIP.Checked Then
            txtDirectIP.ReadOnly = False
        Else
            txtDirectIP.ReadOnly = True
        End If
    End Sub

    Private Sub cboDataBit_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboDataBit.SelectedIndexChanged
        If cboDataBit.SelectedIndex = 2 Then
            cboParity.SelectedIndex = 0
            cboParity.Enabled = False
        Else
            cboParity.Enabled = True
        End If
    End Sub

    Private Sub cboDataBit1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboDataBit1.SelectedIndexChanged
        If cboDataBit1.SelectedIndex = 2 Then
            cboParity1.SelectedIndex = 0
            cboParity1.Enabled = False
        Else
            cboParity1.Enabled = True
        End If
    End Sub
End Class
